import re

from django.db.models import Manager, Q


class EntryManager(Manager):

    def complex_filter(self, **kwargs):
        results = self.all()
        search = kwargs.pop("search", None)
        if search:
            for kw in re.split(r"\s+", search):
                results = results.filter(
                    Q(make__icontains=kw)
                    | Q(models__icontains=kw)
                    | Q(architecture__iexact=kw)
                    | Q(category__iexact=kw))

        kwargs = dict([(k, v) for k, v in kwargs.items() if v is not None])
        results = results.filter(**kwargs)
        return results
