DROP VIEW certification_entry;
CREATE VIEW
    certification_entry
AS SELECT
    a.id AS account_id,
    a.name AS account_name,
    a.website AS account_website,
    h.make,
    h.models,
    h.architecture,
    h.category,
    h.website AS hardware_website,
    h.name AS hardware_name,
    h.certification,
    c.release,
    c.completed,
    count(distinct cn.id) AS notes
FROM
    certification_account a
JOIN
    certification_hardware h ON h.account_id = a.id
JOIN
    certification_certificate c on c.hardware_id = h.id
LEFT JOIN
    certification_certificatenote cn on cn.certificate_id = c.id
GROUP BY
    a.id,
    a.name,
    a.website,
    h.make,
    h.models,
    h.architecture,
    h.category,
    h.website,
    h.name,
    h.certification,
    c.release,
    c.completed;
