import time
from datetime import datetime


FORMAT = "%Y-%m-%dT%H:%M:%S+00:00"


def datetime_to_string(dt):
    return dt.strftime(FORMAT)

def string_to_datetime(string):
    t = time.strptime(string, FORMAT)
    dt = datetime(*t[:-2])
    return dt

def convert_url(url):
    if url and not url.startswith("http"):
        url = "http://%s" % url

    return url

def dict_extract(adict, keys):
    return reduce(lambda x, y: x.update({y[0]:y[1]}) or x,
        map(None, keys, map(adict.get, keys)), {})

def uniquer(seq, func=None):
    if func is None:
        func = lambda x: x
    seen = {}
    result = []
    for item in seq:
        marker = func(item)
        if marker in seen:
            continue
        seen[marker] = 1
        result.append(item)

    return result
