# -*- coding: utf-8 -*-

from django.db import models
from datetime import datetime

# Create your models here.
MONTH_LIST = (
    (1, "January"),
    (2, "February"),
    (3, "March"),
    (4, "April"),
    (5, "May"),
    (6, "June"),
    (7, "July"),
    (8, "August"),
    (9, "September"),
    (10, "October"),
    (11, "November"),
    (12, "December"),
              )

class Country(models.Model):
    Abbreviation = models.CharField(maxlength = 2, primary_key=True)
    Country = models.CharField(maxlength = 50)
    
    class Admin:
        pass
    
    def __str__(self):
        return self.Country

class Partner(models.Model):
    name = models.CharField(maxlength = 80)
    contact_info = models.TextField(help_text = "Enter the contact info exactly how you want users to see it, the web address will be added separately")
    website = models.URLField(verify_exists = False, help_text = "Please ensure the web address for this partner begins with http://")
    
    class Admin:
        pass
    
    def __str__(self):
        return self.name

class TrainingEvent(models.Model):
     Country = models.ForeignKey(Country, help_text = "Country where this event is located")
     Partner = models.ForeignKey(Partner)
     City = models.CharField(maxlength = 50, help_text = "Enter the city name where the event is located, be cautious with the spelling")
     Event_Start = models.DateField()
     Event_Dates = models.CharField(maxlength = 30, help_text = "Enter the dates the way you want users to see them, i.e. 16th - 21st")
     Course_Title = models.CharField(maxlength = 80)
     
     class Admin:
         list_display = ('__str__', 'Country', 'Event_Start')
     
     def __str__(self):
        return "%s @ %s on %s" % (self.Course_Title, self.City, self.Event_Dates)
    
#    def country_list(self, start, end):
#        from django.db import connection
#        cursor = connection.cursor()
#        cursor.execute("SELECT distinct country from 
#        
