# Create your views here.
from django.shortcuts import render_to_response, get_object_or_404
from django.db.models import Q
from trainingwebsite.employment.models import *
from datetime import datetime

def index(request):
    today = datetime.now()
    
    filters = Q(postdate__lte = today) & (Q(expires__gt = today) | Q(expires__isnull = True))
    jobs = Job.objects.filter(filters).order_by('organization','category','-postdate')
    mapping = {'jobs': jobs}
    return render_to_response('employment/views/index.html', mapping)

def post(request, shortname, postid):
    today = datetime.now()
    
    filters = Q(postdate__lte = today) & (Q(expires__gt = today) | Q(expires__isnull = True))
    job = get_object_or_404(Job, Q(organization__shortname = shortname) & Q(postid = postid) & filters)
    if job.howtoapply[0:4] == 'http':
        job.applyurl = job.howtoapply
    mapping = {'job': job}
    return render_to_response('employment/views/post.html', mapping)

def feed(request):
    today = datetime.now()
    
    filters = Q(postdate__lte = today) & (Q(expires__gt = today) | Q(expires__isnull = True))
    jobs = Job.objects.filter(filters).order_by('organization','-postdate')
    mapping = {'jobs': jobs}
    return render_to_response('employment/views/feed.xml', mapping)
