from django.shortcuts import render_to_response
from trainingwebsite.marketplace.models import *
from datetime import datetime

def marketplace_list(request, region = ''):
    now = datetime.now()
    continents = {'africa': 'Africa',
                  'asia': 'Asia',
                  'europe': 'Europe',
                  'northernamerica': 'Northern America',
                  'latinamerica': 'Latin America',
                  'oceania': 'Oceania'
                  }

    partners = Partner.objects.filter(region__exact=continents[region]).filter(expires_date__gt=now).order_by('country','name')
    
        
    mapping = {'continent': continents[region], 'partners': partners}
    return render_to_response('marketplace/views/partner_list.html', mapping)

def index(request):
    return render_to_response('marketplace/views/index.html', {})