# -*- coding: utf-8 -*-

from django.db import models
from datetime import datetime

COUNTRY_LIST = (
    ("AD", "Andorra"),
    ("AF", "Afghanistan"),
    ("AG", "Antigua & Barbuda"),
    ("AI", "Anguilla"),
    ("AL", "Albania"),
    ("AM", "Armenia"),
    ("AO", "Angola"),
    ("AQ", "Antarctica"),
    ("AR", "Argentina"),
    ("AS", "American Samoa"),
    ("AT", "Austria"),
    ("AU", "Australia"),
    ("AW", "Aruba"),
    ("AZ", "Azerbaijan"),
    ("BA", "Bosnia and Herzegovina"),
    ("BB", "Barbados"),
    ("BD", "Bangladesh"),
    ("BE", "Belgium"),
    ("VG", "British Virgin Islands"),
    ("BF", "Burkina Faso"),
    ("BG", "Bulgaria"),
    ("BH", "Bahrain"),
    ("BI", "Burundi"),
    ("BJ", "Benin"),
    ("BM", "Bermuda"),
    ("BN", "Brunei Darussalam"),
    ("BO", "Bolivia"),
    ("BR", "Brazil"),
    ("BS", "Bahama"),
    ("BT", "Bhutan"),
    ("BV", "Bouvet Island"),
    ("BW", "Botswana"),
    ("BY", "Belarus"),
    ("BZ", "Belize"),
    ("CA", "Canada"),
    ("CC", "Cocos (Keeling) Islands"),
    ("CF", "Central African Republic"),
    ("CG", "Congo"),
    ("CH", "Switzerland"),
    ("CI", "Ivory Coast"),
    ("CK", "Cook Iislands"),
    ("CL", "Chile"),
    ("CM", "Cameroon"),
    ("CN", "China"),
    ("CO", "Colombia"),
    ("CR", "Costa Rica"),
    ("CU", "Cuba"),
    ("CV", "Cape Verde"),
    ("CX", "Christmas Island"),
    ("CY", "Cyprus"),
    ("CZ", "Czech Republic"),
    ("DE", "Germany"),
    ("DJ", "Djibouti"),
    ("DK", "Denmark"),
    ("DM", "Dominica"),
    ("DO", "Dominican Republic"),
    ("DZ", "Algeria"),
    ("EC", "Ecuador"),
    ("EE", "Estonia"),
    ("EG", "Egypt"),
    ("EH", "Western Sahara"),
    ("ER", "Eritrea"),
    ("ES", "Spain"),
    ("ET", "Ethiopia"),
    ("FI", "Finland"),
    ("FJ", "Fiji"),
    ("FK", "Falkland Islands (Malvinas)"),
    ("FM", "Micronesia"),
    ("FO", "Faroe Islands"),
    ("FR", "France"),
    ("FX", "France, Metropolitan"),
    ("GA", "Gabon"),
    ("GD", "Grenada"),
    ("GE", "Georgia"),
    ("GF", "French Guiana"),
    ("GH", "Ghana"),
    ("GI", "Gibraltar"),
    ("GL", "Greenland"),
    ("GM", "Gambia"),
    ("GN", "Guinea"),
    ("GP", "Guadeloupe"),
    ("GQ", "Equatorial Guinea"),
    ("GR", "Greece"),
    ("GT", "Guatemala"),
    ("GU", "Guam"),
    ("GW", "Guinea-Bissau"),
    ("GY", "Guyana"),
    ("HK", "Hong Kong"),
    ("HM", "Heard & McDonald Islands"),
    ("HN", "Honduras"),
    ("HR", "Croatia"),
    ("HT", "Haiti"),
    ("HU", "Hungary"),
    ("ID", "Indonesia"),
    ("IE", "Ireland"),
    ("IL", "Israel"),
    ("IN", "India"),
    ("IO", "British Indian Ocean Territory"),
    ("IQ", "Iraq"),
    ("IR", "Islamic Republic of Iran"),
    ("IS", "Iceland"),
    ("IT", "Italy"),
    ("JM", "Jamaica"),
    ("JO", "Jordan"),
    ("JP", "Japan"),
    ("KE", "Kenya"),
    ("KG", "Kyrgyzstan"),
    ("KH", "Cambodia"),
    ("KI", "Kiribati"),
    ("KM", "Comoros"),
    ("KN", "St. Kitts and Nevis"),
    ("KP", "Korea, Democratic People's Republic of"),
    ("KR", "Korea, Republic of"),
    ("KW", "Kuwait"),
    ("KY", "Cayman Islands"),
    ("KZ", "Kazakhstan"),
    ("LA", "Lao People's Democratic Republic"),
    ("LB", "Lebanon"),
    ("LC", "Saint Lucia"),
    ("LI", "Liechtenstein"),
    ("LK", "Sri Lanka"),
    ("LR", "Liberia"),
    ("LS", "Lesotho"),
    ("LT", "Lithuania"),
    ("LU", "Luxembourg"),
    ("LV", "Latvia"),
    ("LY", "Libyan Arab Jamahiriya"),
    ("YT", "Mayotte"),
    ("MA", "Morocco"),
    ("MC", "Monaco"),
    ("MD", "Moldova, Republic of"),
    ("MG", "Madagascar"),
    ("MH", "Marshall Islands"),
    ("ML", "Mali"),
    ("MN", "Mongolia"),
    ("MM", "Myanmar"),
    ("MO", "Macau"),
    ("MP", "Northern Mariana Islands"),
    ("MQ", "Martinique"),
    ("MR", "Mauritania"),
    ("MS", "Monserrat"),
    ("MT", "Malta"),
    ("MU", "Mauritius"),
    ("MV", "Maldives"),
    ("MW", "Malawi"),
    ("MX", "Mexico"),
    ("MY", "Malaysia"),
    ("MZ", "Mozambique"),
    ("NA", "Namibia"),
    ("NC", "New Caledonia"),
    ("NE", "Niger"),
    ("NF", "Norfolk Island"),
    ("NG", "Nigeria"),
    ("NI", "Nicaragua"),
    ("NL", "Netherlands"),
    ("AN", "Netherlands Antilles"),
    ("NO", "Norway"),
    ("NP", "Nepal"),
    ("NR", "Nauru"),
    ("NU", "Niue"),
    ("NZ", "New Zealand"),
    ("OM", "Oman"),
    ("PA", "Panama"),
    ("PE", "Peru"),
    ("PF", "French Polynesia"),
    ("PG", "Papua New Guinea"),
    ("PH", "Philippines"),
    ("PK", "Pakistan"),
    ("PL", "Poland"),
    ("PM", "St. Pierre & Miquelon"),
    ("PN", "Pitcairn"),
    ("PR", "Puerto Rico"),
    ("PT", "Portugal"),
    ("PW", "Palau"),
    ("PY", "Paraguay"),
    ("QA", "Qatar"),
    ("RE", "Réunion"),
    ("RO", "Romania"),
    ("RU", "Russian Federation"),
    ("RW", "Rwanda"),
    ("SA", "Saudi Arabia"),
    ("SB", "Solomon Islands"),
    ("ZA", "South Africa"),
    ("GS", "South Georgia and the South Sandwich Islands"),
    ("SC", "Seychelles"),
    ("SD", "Sudan"),
    ("SE", "Sweden"),
    ("SG", "Singapore"),
    ("SH", "St. Helena"),
    ("SI", "Slovenia"),
    ("SJ", "Svalbard & Jan Mayen Islands"),
    ("SK", "Slovakia"),
    ("SL", "Sierra Leone"),
    ("WS", "Samoa"),
    ("SM", "San Marino"),
    ("SN", "Senegal"),
    ("SO", "Somalia"),
    ("SR", "Suriname"),
    ("ST", "Sao Tome & Principe"),
    ("SV", "El Salvador"),
    ("SY", "Syrian Arab Republic"),
    ("SZ", "Swaziland"),
    ("TC", "Turks & Caicos Islands"),
    ("TD", "Chad"),
    ("TF", "French Southern Territories"),
    ("TG", "Togo"),
    ("TH", "Thailand"),
    ("TJ", "Tajikistan"),
    ("TK", "Tokelau"),
    ("TM", "Turkmenistan"),
    ("TN", "Tunisia"),
    ("TO", "Tonga"),
    ("TP", "East Timor"),
    ("TR", "Turkey"),
    ("TT", "Trinidad & Tobago"),
    ("TV", "Tuvalu"),
    ("TW", "Taiwan, Province of China"),
    ("TZ", "Tanzania, United Republic of"),
    ("UA", "Ukraine"),
    ("UG", "Uganda"),
    ("AE", "United Arab Emirates"),
    ("GB", "United Kingdom (Great Britain)"),
    ("UM", "United States Minor Outlying Islands"),
    ("US", "United States of America"),
    ("VI", "United States Virgin Islands"),
    ("UY", "Uruguay"),
    ("UZ", "Uzbekistan"),
    ("VA", "Vatican City State (Holy See)"),
    ("VC", "St. Vincent & the Grenadines"),
    ("VE", "Venezuela"),
    ("VN", "Viet Nam"),
    ("VU", "Vanuatu"),
    ("WF", "Wallis & Futuna Islands"),
    ("YE", "Yemen"),
    ("YU", "Yugoslavia"),
    ("ZM", "Zambia"),
    ("ZR", "Zaire"),
    ("ZW", "Zimbabwe"),
)

# Create your models here.
class Student(models.Model):
    salutation = models.CharField(maxlength = 10, null = True, blank = True)
    first_name = models.CharField(maxlength = 30)
    last_name = models.CharField(maxlength = 30)
    address = models.TextField("mailing address", 
                              help_text = "Please include stree address, city, state/province and zip or postal code")
    country = models.CharField(maxlength = 2, choices = COUNTRY_LIST)
    email = models.EmailField("email address")
    password = models.CharField(maxlength = 63)
    lpi_id = models.CharField("lpi student id", maxlength = 30, null = True, blank = True, 
                              help_text = "If you have an lpi student ID, enter it here. Otherwise, leave it blank.")
    signup_date = models.DateField(default = datetime.now())
    referred_by = models.CharField(maxlength = 60, null = True, blank = True,
                              help_text = "how did you learn about this program?")
    registered_by = models.CharField(maxlength = 100, null = True, blank = True,
                              help_text = "Please enter your name here.")
    
    class Admin:
        fields = (
          (None, {'fields': ('salutation','first_name','last_name', 'country',
                             'address','email','password','lpi_id', 'signup_date',
                             'referred_by','registered_by')}),
                  )
    
    def __str__(self):
        return "%s %s (%s)" % (self.first_name, self.last_name, self.country)
    
class Course(models.Model):
    course_name = models.CharField(maxlength = 100)
    course_description = models.TextField()
    
    def __str__(self):
        return self.course_name
    
    class Admin:
        pass

class Partner(models.Model):
    partner_name = models.CharField(maxlength = 100)
    
    def __str__(self):
        return self.partner_name
    
    class Admin:
        pass

class CoursesOffered(models.Model):
    partner = models.ForeignKey(Partner)
    course = models.ForeignKey(Course)
    
    class Admin:
        pass
    
    def __str__(self):
        return "%s at %s" % (self.course.course_name, self.partner.partner_name)

class CoursesTaken(models.Model):
    student = models.ForeignKey(Student)
    course = models.ForeignKey(Course)
    date_taken = models.DateTimeField()
    passed = models.BooleanField()
    notes = models.TextField()
    
    class Admin:
        pass
    
    class Meta:
        verbose_name = "Course Taken"
        verbose_name_plural = "Courses Taken"
    
    def __str__(self):
        if self.passed:
            status = "passed"
        else:
            status = "failed"
        return "%s %s/%s on %s (%s)" % (self.student.first_name, 
                                        self.student.last_name, 
                                        self.course.course_name,
                                        self.date_taken, status)