from django.conf.urls.defaults import *
from django.conf import settings

# Static files
urlpatterns = patterns('',
    (r'favicon.ico$', 'django.views.static.serve',
        {'document_root': settings.MEDIA_ROOT, 'path': 'favicon.ico'}),
    (r'^certification/style.css$', 'django.views.static.serve',
        {'document_root': settings.MEDIA_ROOT, 'path': 'certification.css'}),
)

# Dynamic files
urlpatterns += patterns('trainingwebsite',
    # Example:
    (r'^trainingwebsite/', include('trainingwebsite.students.urls')),
    (r'^formmail/', include('trainingwebsite.formmail.urls')),
    (r'^course_locator/', include('trainingwebsite.course_locator.urls')),
    (r'^partners/', include('trainingwebsite.partners.urls')),
    (r'^certification/', include('trainingwebsite.certification.urls')),
    (r'^employment/', include('trainingwebsite.employment.urls')),
    (r'^marketplace/', include('trainingwebsite.marketplace.urls')),
    (r'^$', 'course_locator.views.index'),

    # Uncomment this for admin:
    (r'^admin/', include('django.contrib.admin.urls')),
)

if settings.DEBUG:
    urlpatterns += patterns('',
        (r'^assets/webapps/(?P<path>.*)$', 'django.views.static.serve',
            {'document_root': settings.MEDIA_ROOT}),
        (r'^assets/(?P<path>.*)$', 'django.views.static.serve',
            {'document_root': settings.WEB_THEMES_DIR + '/assets/'}),
    )
